#include<stdio.h>
#include<stdlib.h>
#include<string.h>


#define schar signed char
#define uchar unsigned char
#define ushort unsigned short
#define uint unsigned int
#define ulong unsigned long


#define get_u16(p) ((p)[0] | ((p)[1] << 8))



static long expand(uchar *dest, uchar *src, long src_size){
	uchar *dest_ptr;
	uchar *flag_ptr, *dat_ptr;
	uchar *dat_end;


	dest_ptr = dest;
	flag_ptr = (src + 0x10);
	dat_ptr = (src + get_u16(src + 2));
	dat_end = (src + src_size);

	while(dat_end > dat_ptr){
		int c, k;
		c = flag_ptr[0];
		flag_ptr += 1;

		for(k = 0; 4 > k; ++k){

			if(dat_end <= dat_ptr){
				break;
			}

			switch(c >> 6){
				case 0:
					{
						int n;
						n = dat_ptr[0];
						dat_ptr += 1;
						memcpy(dest_ptr, dat_ptr, n);
						dest_ptr += n;
						dat_ptr += n;
					}
					break;

				case 1:
					{
						int n;
						n = (dat_ptr[0] + 3);
						memset(dest_ptr, dat_ptr[1], n);
						dest_ptr += n;
						dat_ptr += 2;
					}
					break;

				case 2:
				case 3:
					{
						int n, p;
						uchar *t_ptr;
						p = dat_ptr[0];
						n = dat_ptr[1];
						if((c >> 6) == 2){
							p |= ((n & 0x0F) << 8);
							n = ((n >> 4) + 3);
						}
						else{
							p |= ((n & 1) << 8);
							n = ((n >> 1) + 3);
						}
						if(p >= (dest_ptr - dest)){
							memset(dest_ptr, 0, n);
						}
						else{
							int j;
							t_ptr = (dest_ptr - p);
							for(j = 0; n > j; ++j){
								dest_ptr[j] = t_ptr[j];
							}
						}
						dest_ptr += n;
						dat_ptr += 2;
					}
					break;
			}
			c = ((c << 2) & 0xFF);
		}
	}

	return (dest_ptr - dest);
}



int main(int argc,char *argv[]){
	char *src_name, *dest_name;
	int fl_expand;
	int fl_nonarc;

	if(2 > argc){
		exit(0);
	}

	src_name = NULL;
	dest_name = NULL;
	fl_expand = 0;
	fl_nonarc = 0;

	{
		int k;
		for(k = 1; argc > k; ++k){
			if((argv[k][0] == '-') || (argv[k][0] == '/')){
				switch(argv[k][1]){
					case 'E': case 'e':
						fl_expand = 1;
						break;
					case 'S': case 's':
						fl_expand = 0;
						break;
					case 'N': case 'n':
						fl_nonarc = 1;
						break;
				}
			}
			else{
				if(NULL == src_name){
					src_name = argv[k];
				}
				else if(NULL == dest_name){
					dest_name = argv[k];
				}
			}
		}
	}

	if(NULL == src_name){
		exit(0);
	}
	if(NULL == dest_name){
		dest_name = "";
	}

	{
		FILE *f_in;
		uchar *tbl;
		int num;
		int k;

		f_in = fopen(src_name, "rb");
		if(NULL == f_in){
			exit(1);
		}
		tbl = (uchar*)malloc(0x400);
		if(NULL == tbl){
			fclose(f_in);
			exit(1);
		}
		if(0 == fl_nonarc){
			k = fread(tbl, 1, 0x400, f_in);
			if(0x400 != k){
				free(tbl);
				fclose(f_in);
				exit(1);
			}
		}
		else{
			int t;
			fseek(f_in, 0, SEEK_END);
			t = ftell(f_in);
			fseek(f_in, 0, SEEK_SET);
			tbl[0] = 1;
			tbl[1] = 0;
			tbl[2] = (t & 0xFF);
			tbl[3] = (t >> 8);
		}

		num = get_u16(tbl);
		for(k = 1; num >= k; ++k){
			long size, t_size;
			void *buf;

			size = get_u16(tbl + (k * 2));
			if(0 == size){
				continue;
			}
			t_size = ((size + 0x3FF) & ~0x3FF);

			buf = malloc(t_size);
			if(NULL == buf){
				break;
			}
			fread(buf, 1, t_size, f_in);

			if(0 != fl_expand){
				void *exp_buf;
				exp_buf = malloc(0x8000);
				if(NULL == exp_buf){
					free(buf);
					fclose(f_in);
					exit(1);
				}
				t_size = expand(exp_buf, buf, size);
				if(0 >= t_size){
					free(exp_buf);
					free(buf);
					fclose(f_in);
					exit(1);
				}
				free(buf);
				buf = exp_buf;
			}

			{
				FILE *f_out;
				char name_buf[32];

				if(0 == fl_nonarc){
					sprintf(name_buf, "%s%02d.bin", dest_name, k);
				}
				else{
					if('\0' != dest_name[0]){
						strcpy(name_buf, dest_name);
					}
					else{
						char *t;
						strcpy(name_buf, src_name);
						t = strrchr(name_buf, '.');
						if(NULL == t){
							t = (name_buf + strlen(name_buf));
						}
						strcpy(t, ".bin");
					}
				}
				f_out = fopen(name_buf, "wb");
				fwrite(buf, 1, t_size, f_out);
				fclose(f_out);
			}

			free(buf);
		}

		fclose(f_in);
	}

	exit(0);
}
